//Global variables
var lang = "en";
var dir = "ltr";
var showTrans = false;
var showMenu = false;
var muted = false;
var showVolume = false;
var paused = true;
var currentAudio;
var turnoffAudio = "false";
var userClick=false;
var courseMap = courseMap;
var currentLessonNum = 0;
var currentLessonNumLength;
var currentPageNum = 0;
var currentPageCounter = 1;
var totalPageNum = 0;
var totalLessonNum = 0;
var currentFileName;
var courseTitle;
var lessonTitle;
var pageTitle;
var is_fullscreen =false;
var first_page_opened = false;
//For Menu
var totalTopics = [];
var totalSubTopics = [];

//For Browsers
var isIE = false;
var isFF = false;
var isOP = false;
var isSafari = false;
var isChrome = false;

//var length=0;


//LMS variables
var bookmark = 0;
var courseStatus;
var scoreNonLMS = 0;
var scoreLMS = 0;
var pageStatus = [
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
			      [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0],
				  [0,0,0]

                 ];

///iphone|ipod|ipad/ detection::::::::::::::::::::
var standalone = window.navigator.standalone,
	userAgent = window.navigator.userAgent.toLowerCase(),
	safari = /safari/.test( userAgent ),
    ios = /iphone|ipod|ipad/.test( userAgent );
	ipad = /ipad/.test( userAgent );

//var ios = true;
if( ios ) {
    if ( !standalone && safari ) {
		//alert("browser");
    } else if ( standalone && !safari ) {
		//alert("standalone");
    } else if ( !standalone && !safari ) {
		//alert("uiwebview");
    };
} else {
	//alert("not iOS");
};
//Broswer detection::::::::::::::::::::
if(userAgent.indexOf("firefox") > -1)
{
isFF = true;
//alert("isFF");
}
else if(userAgent.indexOf("opera") > -1)
{
isOP = true;
//alert("isOP");
}
else if(userAgent.indexOf("msie") > -1)
{
isIE = true;
//alert("isIE");
}
else if(userAgent.indexOf("chrome") > -1)
{
isChrome = true;
//alert("isChrome");
}
else if(userAgent.indexOf("safari") > -1)
{
isSafari = true;
//alert("isSafari");
}


//Mobile detection::::::::::::::::::::
var isMobile = {
    Android: function() {
        return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function() {
        return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function() {
        return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function() {
        return navigator.userAgent.match(/IEMobile/i);
    },
    any: function() {
        return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
    }
};


function setPlayer()
	{		
		totalLessonNum = courseMap.topics.length;		
		
		for (i=0; i<totalLessonNum; i++){
			totalPageNum += courseMap.topics[i].screens.length;							
		}
		
			
		 //button variables
		 menuBtn=document.getElementById('menuBtn');
		 langBtn=document.getElementById('langBtn');
		 audioBtn=document.getElementById('audioBtn');
		 ttBtn=document.getElementById('ttBtn');
		 transcriptText=document.getElementById('transcript');
	 	 backBtn=document.getElementById('backBtn');
		 nextBtn=document.getElementById('nextBtn');			 
		 helpBtn=document.getElementById('helpBtn');
		 exitBtn=document.getElementById('exitBtn');
		 replayBtn=document.getElementById('replayBtn');			 
		 playPauseBtn=document.getElementById('playPauseBtn');
		 getStartedBtn=document.getElementById('getStartedBtn');

		if(_isLms){		    
		    getValuesFromLms();
		}else{
			loadPage(0);
		}
		 setLang(lang, dir);		 
		 volumeController();		 
		 document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);

		 $("#loader").css("display","none");	

	}

//Load page:::::::::::::::::::::
function loadPage(id){		
		try{
			if(currentAudio)
			currentAudio.pause();
		}catch(e)
		{
		}
		
		currentPageNum = Number(id);		
		currentFileName =  courseMap.topics[currentLessonNum].screens[currentPageNum].src
		currentLessonNumLength = courseMap.topics[currentLessonNum].screens.length;
		myVar = "html/"+currentFileName+".html";	
		$("#pageContainer").attr("src", myVar);
		showVolume=false;
		$("#volumeSlider").css("display","none");
	
		showLessonPageTitle();
		showPagecounter();
		disableAllBtns();
		loadOtherAudio();
		transcriptText.innerHTML= eval("courseMap.topics[currentLessonNum].screens[currentPageNum].trans_"+lang);
		pageStatus[currentPageCounter-1] = [1,0,0];		

		for (i=1; i<=totalPageNum; i++){
		   if(pageStatus[i-1][0] == 1)
		   {
		    $(".p"+i).removeClass("pageTitleContDisbled").removeClass("pageTitleContActive").addClass("pageTitleContVisited").attr("onClick","loadPageFromMenu(this.id)");
		   }else{
		    //$(".p"+i).addClass("pageTitleContDisbled");        
		    $(".p"+i).removeClass("pageTitleContDisbled").removeClass("pageTitleContActive").addClass("pageTitleCont").attr("onClick","loadPageFromMenu(this.id)");
		   }
		  }
		  $(".p"+currentPageCounter).removeClass("pageTitleContVisited").addClass("pageTitleContActive").removeAttr("onClick");
		  //==================  function calling to set values from course to LMS ======================//
		  if(_isLms){
		   updateLMS();
		  }  
		 }
//Page Counter:::::::::::
function showPagecounter(){
		if (lang == "en"){
			if (currentPageCounter<=9 && totalPageNum<=9){
				$("#currentPageNum").text("Page 0"+Number(currentPageCounter)+" / 0"+Number(totalPageNum));
			}else if (currentPageCounter<=9 && totalPageNum>9){
				$("#currentPageNum").text("Page 0"+Number(currentPageCounter)+" / "+totalPageNum);
			}else{
				$("#currentPageNum").text("Page "+currentPageCounter+" / "+totalPageNum);
			}
		}else if (lang == "ar"){
			if (currentPageCounter<=9 && totalPageNum<=9){
				$("#currentPageNum").text("صفحة 0"+Number(currentPageCounter)+" / 0"+Number(totalPageNum));
			}else if (currentPageCounter<=9 && totalPageNum>9){
				$("#currentPageNum").text("صفحة 0"+Number(currentPageCounter)+" / "+totalPageNum);
			}else{
				$("#currentPageNum").text("صفحة "+currentPageCounter+" / "+totalPageNum);
			}
		}		
}
//LessonTitle and Page title:::::::::::
function showLessonPageTitle(){		
		courseTitle = eval("courseMap.courseTitle_"+lang);
		lessonTitle = eval("courseMap.topics[currentLessonNum].title_"+lang);		
		pageTitle = eval("courseMap.topics[currentLessonNum].screens[currentPageNum].title_"+lang);
		$("#courseTitle").text(courseTitle);
		$("#lessonTitle").text(lessonTitle+" > "+pageTitle);
}
//Navigation::::::::::::::::::::
function enableAllBtns(){
      $("#midNavButtons").css("display","block");
	  $("#midNavButtons2").css("display","none");
	 enableBtn(langBtn, changeLang, 'langBtn');
	 //enableBtn(audioBtn, audioControls, 'audioBtn');
	 if(currentAudio.volume>0){
	 	enableBtn(audioBtn, audioControls, 'audioBtn');
	 }else{
	 	enableBtn(audioBtn, audioControls, 'audioOffBtn');
	 }
	 if(showMenu){	 	
		disableBtn(menuBtn, showMainMenu, 'menuBtnDisabled');
	 }else{	 	
	 	enableBtn(menuBtn, showMainMenu, 'menuBtn');
	 }

	 if(showTrans){	 	
		disableBtn(ttBtn, showTranscript, 'ttBtnDisabled');
	 }else{	 	
	 	enableBtn(ttBtn, showTranscript, 'ttBtn');
	 }

	 enableBtn(helpBtn, helpControls, 'helpBtn');
	 enableBtn(exitBtn, exitCourse, 'exitBtn');	 
	 enableBtn(replayBtn, replayControls, 'replayBtn');
	 enableBtn(playPauseBtn, playPauseControls, 'playPauseBtn');
	 
	 if (currentPageCounter==0){
			disableBack();
	 }else {
			enableBack();
	 }
	if (currentPageCounter==totalPageNum){			
			disableNext();
	}else{
			enableNext();
	}

	enableBtn(getStartedBtn, loadAudioAndNext, 'getStartedBtn');
}
function disableAllBtns(){
	disableBtn(menuBtn,showMainMenu,'menuBtnDisabled');
	disableBtn(langBtn, changeLang, 'langBtnDisabled');
	//disableBtn(audioBtn, audioControls, 'audioBtnDisabled');
	if(currentAudio.volume>0){
	 	disableBtn(audioBtn, audioControls, 'audioBtnDisabled');
	}else{
	 	disableBtn(audioBtn, audioControls, 'audioOffBtnDisabled');
	}
	disableBtn(ttBtn, showTranscript, 'ttBtnDisabled');
	disableBtn(helpBtn, helpControls, 'helpBtnDisabled');
	disableBtn(replayBtn, replayControls, 'replayBtnDisabled');
	disableBtn(playPauseBtn, playPauseControls, 'pauseBtnDisabled');	
	disableBack()
	disableNext();		
}
function disableBtn(btnName, func, disableClassName){
	btnName.className = disableClassName;
	btnName.removeEventListener('click',func,false);
}
function enableBtn(btnName, func, enableClassName){
	btnName.className = enableClassName;
	btnName.addEventListener('click',func,false);
}

//exitCourses controls::::::::::::::::::::
function exitCourse() {

	if(turnoffAudio=="false"){
		if (!currentAudio.ended){
			if (paused==true){
				currentAudio.pause();
			}
		}
	}	
	$(".exitWrap").css("display","block");
	$(".exit_"+lang).css("display","block");	
}

function exitCourseClose(){
	$(".exitWrap").css("display","none");
	$(".exit_"+lang).css("display","none");
	if(turnoffAudio=="false"){
		if (!currentAudio.ended){
			if (paused==true){
				currentAudio.play();
			}
		}
	}	
}

function quitCourse(cmd)
{   
    if (cmd=='quit')
    {
    	 window.open(location, '_self').close(); 
         window.open("http://ise.skills4success.co/launch/lesson.asp", '_self').close(); 
    }   
    return false;   
}


//Next page::::::::::::::::::::
function loadNextPage(){
	currentPageCounter++;
	if (currentPageNum==currentLessonNumLength-1){			
		currentLessonNum++;
		currentPageNum = 0;
		loadPage(currentPageNum);
	}else{
		currentPageNum++;
		loadPage(currentPageNum);
	}
				
}		

function enableNext(){
	nextBtn.className = 'nextBtn';
	nextBtn.addEventListener('click',loadNextPage,false);
}
function disableNext(){
	nextBtn.className = 'nextBtnDisabled';
	nextBtn.removeEventListener('click',loadNextPage,false);
}

//Previous page::::::::::::::::::::
function loadPreviousPage(){
	currentPageCounter--;	
	if (currentPageNum==0){
		currentLessonNum--;		
		currentLessonNumLength = courseMap.topics[currentLessonNum].screens.length;
		currentPageNum = currentLessonNumLength-1;
		//console.log(currentLessonNumLength);		
		loadPage(currentPageNum);
	}else{
		currentPageNum--;
		loadPage(currentPageNum);
	}
		
}
function enableBack(){
	backBtn.className = 'backBtn';
	backBtn.addEventListener('click',loadPreviousPage,false);
}
function disableBack(){
	backBtn.className = 'backBtnDisabled';
	backBtn.removeEventListener('click',loadPreviousPage,false);
}	

//Audio controls::::::::::::::::::::
function audioControls () {
	showVolume = !showVolume;
	if(showVolume){
		$("#volumeSlider").css("display","block");
		
	}else{
		$("#volumeSlider").css("display","none");
		
	}
}

function volumeController(){	
	$("#volumeSlider").slider({
            orientation: "horizontal",
            range: "min",
            min: 0,
            max: 1,
            step: 0.1,
            value: 0.5,
            disabled: false,
            slide: function(event, ui) {
                currentAudio.volume =  ui.value;
                if(ui.value==0){                	
                	audioBtn.className = "audioOffBtn";
                }else{
                	audioBtn.className = "audioBtn";
                }              
            }
        });
}
function playAudio(fn){	
	timeUpdate=fn
	currentAudio.play();
	playPauseBtn.className = 'pauseBtn';			
	paused=true;
	currentAudio.addEventListener('timeupdate',fun,false);
	currentAudio.addEventListener('ended',playPauseControls,false);
	//alert(currentAudio.muted)
	if (muted)
	{		
		currentAudio.muted = true;
		//alert(currentAudio.muted)
	}	
}
function fun()
{
	timeUpdate();
}

//help controls::::::::::::::::::::
function helpControls(){	
	if(turnoffAudio=="false"){
		if (!currentAudio.ended){
			if (paused==true){
				currentAudio.pause();
			}
		}
	}
	$(".helpWrap").css("display","block");
	$(".help_"+lang).css("display","block");
}

function helpClose(){
	$(".helpWrap").css("display","none");
	$(".help_"+lang).css("display","none");
	if(turnoffAudio=="false"){
		if (!currentAudio.ended){
			if (paused==true){
				currentAudio.play();
			}
		}
	}
}
//Replay controls::::::::::::::::::::
function replayControls(){
		loadPage(currentPageNum);
		enableBtn(playPauseBtn, playPauseControls, 'pauseBtn');					
		paused=true;
}
//Play/Puase controls::::::::::::::::::::
function playPauseControls () {	
	if (!currentAudio.ended){
		if (paused==false){
			playPauseBtn.className = 'pauseBtn';
			paused=true;
			currentAudio.play();
		}else{
			playPauseBtn.className = 'playBtn';
			paused=false;
			currentAudio.pause();
		}
	
	}else{
		disableBtn(playPauseBtn, playPauseControls, 'pauseBtnDisabled');				
	}
}
//Transcript controls::::::::::::::::::::
function showTranscript () {
	showTrans = true;
	disableBtn(ttBtn, showTranscript, 'ttBtnDisabled');		
	document.getElementById("ttpane").style.visibility = 'visible';
}
function hideTranscript(){
	showTrans = false;
	enableBtn(ttBtn, showTranscript, 'ttBtn');
	document.getElementById("ttpane").style.visibility = 'hidden';
}
//Language controls::::::::::::::::::::
function setLang(l, d){
	lang = l;
	dir = d;
	$("html").attr("lang",lang);
	$("html").attr("dir",dir);
}
function changeLang () {
	if(showMenu){
		hideMenu();
	}	
	if (lang == "en"){
		lang ="ar";
		dir = "rtl";
	}else if (lang == "ar"){
		lang ="en";
		dir = "ltr";	
	}
	$("html").attr("lang",lang);
	$("html").attr("dir",dir);
	
	loadPage(currentPageNum);
}
//Menu controls::::::::::::::::::::
function showMainMenu () {
	showMenu = true;
	disableBtn(menuBtn, showMainMenu, 'menuBtnDisabled');		
	$(".menuPane").css("display","block");
	$(".menu_"+lang).css("display","block");

}
function hideMenu(){
	showMenu = false;	
	$(".menuPane").css("display","none");
	$(".menu_"+lang).css("display","none");
	enableBtn(menuBtn, showMainMenu, 'menuBtn');
}
function loadPageFromMenu(id){

	var tmpPageId = id.split("_");
	currentLessonNum = Number(tmpPageId[1]);	
	currentPageNum = Number(tmpPageId[2]);
	currentPageCounter = Number(tmpPageId[3]);
	loadPage(currentPageNum);
	hideMenu();
     $(".pageTitleContVisited").find("div").css("background-color", "#CDCDCD"); 
}


//Function to set values from course to LMS::::::::::
function updateLMS(){
	bookmark = currentLessonNum+"_"+currentPageNum+"_"+currentPageCounter+"_"+lang+"_"+dir+"_"+currentAssessmentQuestion+"_"+assessmentResult;	
	var count = 0;
	for(var i=0; i<totalPageNum; i++){
		if(pageStatus[i][0]==1){
			count++;
			if (count == totalPageNum){
		   		courseStatus = "completed";
		  	}else{
				courseStatus = "incomplete";
		 	}
		}
	}	
	doSetValue("cmi.location", String(bookmark));
	doSetValue("cmi.completion_status", String(courseStatus));
	doSetValue("cmi.suspend_data", String(pageStatus));
	doSetValue("cmi.score.scaled", String(scoreLMS));

	if(courseStatus == "incomplete")
	  {
      doSetValue("cmi.success_status", "InProgress");  
	  }
	else if(scoreLMS>=0.50){
		doSetValue("cmi.success_status", "passed");
	}else{
		doSetValue("cmi.success_status", "failed");
	}
	doCommit();	
}

function loadBookmark(){	
	$(".bookmarkWrap").css("display","block");
	$(".bookmark_"+lang).css("display","block");
}
function bookmarkClose(id){
	if(!id){
		currentLessonNum = 0;
		currentPageNum = 0;
		currentPageCounter = 1;
	}
	loadAudio(); 
	loadPage(currentPageNum);
	$(".bookmarkWrap").css("display","none");
	$(".bookmark_"+lang).css("display","none");
}


function fix()
{
    var el = this;
    var par = el.parentNode;
    var next = el.nextSibling;
    par.removeChild(el);
    setTimeout(function() {par.insertBefore(el, next);}, 0)
}

function setViewPort(){	
	var mvp = document.getElementById('myViewport');
	var winHeight = window.screen.availHeight;
	var winOrientation = window.orientation;
	//alert("winHeight"+window.screen.availHeight);
	if(winOrientation==0 || winOrientation==180){
		//alert("portrait");
		if(turnoffAudio=="false"){
			if (!currentAudio.ended){
				if (paused==true){
					currentAudio.pause();
				}
			}
		}

		$('#bodyContainer').css('display','none');	
		$('#portraitMode').css('display','block');

	}else{
		//alert("landscape");
		if(is_fullscreen==true)
		  {
				if(turnoffAudio=="false"){
					if (!currentAudio.ended){
						if (paused==true){
							currentAudio.play();
						}
					}
				}

				$('#bodyContainer').css('display','block');	
				$('#portraitMode').css('display','none');
				
				if (winHeight >= 320 && winHeight < 360){
					mvp.setAttribute('content','initial-scale=0.40, minimum-scale=0.40, maximum-scale=2,user-scalable=yes');
				}else if (winHeight >= 360 && winHeight < 375){		
					mvp.setAttribute('content','initial-scale=0.42, minimum-scale=0.42, maximum-scale=2,user-scalable=yes');
				}else if (winHeight >= 375 && winHeight < 414){		
					mvp.setAttribute('content','initial-scale=0.45, minimum-scale=0.45, maximum-scale=2,user-scalable=yes');
				}else if (winHeight >= 414 && winHeight < 480){		
					mvp.setAttribute('content','initial-scale=0.46, minimum-scale=0.46, maximum-scale=2,user-scalable=yes');
				}else if (winHeight == 480){		
					mvp.setAttribute('content','initial-scale=0.45, minimum-scale=0.45, maximum-scale=2,user-scalable=yes');
				}else if (winHeight == 568){		
					mvp.setAttribute('content','initial-scale=0.47, minimum-scale=0.47, maximum-scale=2,user-scalable=yes');
				}else if (winHeight == 667){		
					mvp.setAttribute('content','initial-scale=0.48, minimum-scale=0.48, maximum-scale=2,user-scalable=yes');
				}else if (winHeight >= 736 && winHeight < 700){		
					mvp.setAttribute('content','initial-scale=0.49, minimum-scale=0.49, maximum-scale=2,user-scalable=yes');
				}else if (winHeight >= 700){		
					mvp.setAttribute('content','width=1010');		
				}

		  }
		  else
		  {
		  	$('#portraitMode').css('display','none');
		  	$('.fullscreen_container').css('display','block');	
		  }


	}
}
//launchIntoFullscreen(document.documentElement);
function launchIntoFullscreen(element) {
  if(element.requestFullscreen) {
    element.requestFullscreen();
  } else if(element.mozRequestFullScreen) {
    element.mozRequestFullScreen();
  } else if(element.webkitRequestFullscreen) {
    element.webkitRequestFullscreen();
  } else if(element.msRequestFullscreen) {
    element.msRequestFullscreen();
  }
}
